"use strict";
/*global angular, window, cordova, app*/

app.controller('LoginController', ['$rootScope', '$scope', '$ionicLoading', '$ionicPopup', '$state', '$http', '$window', '$timeout', '$authService', '$iot', '$ionicPlatform', function ($rootScope, $scope, $ionicLoading, $ionicPopup, $state, $http, $window, $timeout, $authService, $iot, $ionicPlatform) {
    var app = {};
    // Calling cordova plugin cordova-plugin-app-version

    if (typeof cordova !== "undefined") {
        cordova.getAppVersion.getVersionNumber().then(function (version) {
            $timeout(function () {
                app = {};
                app.version = version;
            }, 0);
        });
        cordova.getAppVersion.getVersionCode().then(function (versionBuild) {
            $timeout(function () {
                app.build = versionBuild;
                window.localStorage.setItem("appVersion",JSON.stringify(app));
            }, 0);
        });
    }

    var rot13 = function(s, type) {
        return s.replace(/[A-Za-z]/g, function (c) {
            return "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".charAt(
                "NOPQRSTUVWXYZABCDEFGHIJKLMnopqrstuvwxyzabcdefghijklm".indexOf(c)
            );
        });
    };

    $scope.state = {
        userName: rot13(window.localStorage.getItem('username') || ""),
        password: rot13(window.localStorage.getItem('password') || ""),
        error: null,
        loged: false,
        robots: [],
        uuid: "D43433FGHGTRVBT5432O",
        product: {},
        screen: "login",
        new: {
            userName: "",
            password: ""
        },
        recoverEmail: "",
        productName: null,
        userproductList: [],
        remember: true,
        newPasswordType: "password"
    };
    
    $scope.hgt = window.screen.height;

    $timeout(function() {
        $scope.ready = true;
    }, 700);

    $scope.random = Math.floor(Math.random() * 6) + 1;

    if ($scope.state.loged) {
        $scope.random = 7;
    }

    if (window.localStorage.getItem("userproductList")) {        
        $scope.state.userproductList = JSON.parse(window.localStorage.getItem("userproductList"));
    }

    $scope.serverUrl = window.serverUrl;

    if (window.localStorage.getItem("switcRobot")) {
        //$scope.state.loged = true;
        var productList = window.localStorage.getItem("productList");
        if (productList && productList !== null && productList.length > 0) {
            $scope.state.robots = JSON.parse(productList);
        }
    };

    //set logged
    var productList = window.localStorage.getItem("productList");
    if (productList && productList !== null && productList.length > 0) {
        $scope.state.robots = JSON.parse(productList);
        //$scope.state.loged = true;
        $scope.random = 7;
    }

    $scope.register = function () {
        $scope.state.error = "";
        if (/^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test($scope.state.new.userName) === false) return $scope.state.error = "Input a valid email address";
        if ($scope.state.new.password.length < 6) return $scope.state.error = "The password is too short";

        $ionicLoading.show();
        console.log($scope.state.new.userName);
        var pass = CryptoJS.MD5($scope.state.new.password).toString();

        //$http.post('https://2mk786bvj2.execute-api.us-east-1.amazonaws.com/v2stage/foundry/signup',  {'username': $scope.state.new.userName, 'password': pass}).then(
        $http.post('https://3zera33ryl.execute-api.us-west-2.amazonaws.com/v2prod/foundry/signup',  {'username': $scope.state.new.userName, 'password': pass}).then(
            function (res) {
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: 'Congratulations!',
                    template: 'Your account was created, however you have to activate it by using the link we sent to your email address. Once your account is active, please login to the app.'
                });
                $scope.state.new.password = "";
                $scope.state.new.userName = "";
                $scope.state.password = $scope.state.new.password;
                $scope.state.userName = $scope.state.new.userName;
                $scope.state.screen = "login";
            },
            function (e) {
                $ionicLoading.hide();
                var errMsg = (e.data.error !== null && e.status === 400) ? "The provided email address already exist." : "There was an error registering your account, please try again";
                $scope.state.error = errMsg;
            }
        )
    };

    $scope.recover = function () {
        $scope.state.error = "";
        if (/^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test($scope.state.recoverEmail) === false) return $scope.state.error = "Input a valid email address";
        $ionicLoading.show();

        //$http.post('https://2mk786bvj2.execute-api.us-east-1.amazonaws.com/v2stage/foundry/forgot-password',  {'email': $scope.state.recoverEmail}).then(
        $http.post('https://3zera33ryl.execute-api.us-west-2.amazonaws.com/v2prod/foundry/forgot-password',  {'email': $scope.state.recoverEmail}).then(
            function (res) {
                $ionicLoading.hide();
                if (res.data && res.data.error) {
                    $scope.state.recoverEmail = "";
                    return $scope.state.error = res.data.error;
                }
                $ionicPopup.alert({
                    title: 'Password Recovery',
                    template: 'An email has been sent to you inbox with further instructions regarding how to restore your password.'
                });
                $scope.state.recoverEmail = "";
                $scope.state.password = "";
                $scope.state.screen = "login";
            },
            function (e) {
                $ionicLoading.hide();
                $scope.state.error = "Invalid email address.";
            }
        )
    }

    $scope.getUserRobots = function (fromPull) {
        $ionicLoading.show();
        $authService.getApiGatewayClient({username: $scope.state.userName, password: $scope.state.password}, function(err, client){
            if (!err){
                var userId = window.localStorage.getItem('userId');
                client.Get('/foundry/devices/by-type', {type_id: "fb648690-3eed-11e7-9b5d-5763b2661e96", account_id: userId}).then(function (result) {
                    var list = [];
                    (result.data || []).forEach(function(item) {
                        if (item.accountId === userId) {
                            var robot = null;
                            var debug = (item["a.enable_debug"] === "1");
                            ($scope.state.robots || []).forEach(function (r) {
                                if (r.typeId === item["a.product"]) robot = r
                            });
                            list.push({id: item.deviceId, robot_id: item["a.robot_id"], "name": item["a.name"], product: robot, userStaticUrl: null, 'appStyle': robot.skin, config: item["a.config_data"], debug: debug});
                        }
                    })
                    $scope.state.userproductList = list;
                    window.localStorage.setItem("userproductList", JSON.stringify(list));
                    $ionicLoading.hide();
                    if(fromPull) {
                        $scope.$broadcast('scroll.refreshComplete');
                        $scope.$apply();
                    }

                }).catch(function (err) {
                    return err.data;
                });
            } else {
                $ionicLoading.hide();
                $scope.state.error = err;
            }
        });
    };

    if ($scope.state.loged) {
        $scope.getUserRobots();
    }

    $scope.doRefresh = function () {
        $scope.getUserRobots(true);
    };

    $scope.getSTSK  = function () {
        $authService.getApiGatewayClient({username: $scope.state.userName, password: $scope.state.password}, function(err, client){
            if (!err){
                var login = encodeURI(window.localStorage.getItem("robart_user_login"));
                client.Get('/foundry/stsk', {}).then(function (result) {
                    if (result && result.data && result.data.stsk && result.data.robart_user_login) {
                        var robart_iot_info = {stsk: result.data.stsk, robart_user_login: result.data.robart_user_login};
                        window.localStorage.setItem("robart_iot_info", JSON.stringify(robart_iot_info))
                    }
                })
            }
        });
    };

    $scope.login = function () {
        $scope.state.error = "";

        if ($scope.state.userName.length < 1) return $scope.state.error = "Input a valid username";
        if ($scope.state.password.length < 6) return $scope.state.error = "The password is wrong";

        $ionicLoading.show();
        var credentials = {
            username: $scope.state.userName,
            password: $scope.state.password
        }
        console.log('Credentials:  ',credentials);

        $authService.getApiGatewayClient(credentials, function(err, client){
            if (!err){
                if ($scope.state.remember) {
                    $scope.state.robots = [];
                    window.localStorage.setItem('username', rot13($scope.state.userName))
                    window.localStorage.setItem('password', rot13($scope.state.password))
                }
                console.log('Credentials:  ',credentials);
                $scope.clearProductCache();
                var apiClient = client;
                var query = {type_id: "62a0df70-3a34-11e7-8b9e-bf1700f5a25c"};
                var result = apiClient.Get('/foundry/devices/by-type', query).then(function (result) {
                    result.data.forEach(function(r) {
                        $scope.state.robots.push({version: r["a.version"], name: r["a.robot"], skin: r["a.name"].toLowerCase(), hpm: r["a.hpm_file"], image: r["a.image"], typeId: r["deviceId"]})
                    })
                    $scope.random = 7;
                    $scope.state.loged = true;
                    window.localStorage.setItem("productList", JSON.stringify($scope.state.robots));
                    if (window.localStorage.getItem("userproductList")) {
                        $scope.state.userproductList = JSON.parse(window.localStorage.getItem("userproductList"));
                    }

                    // $scope.getSTSK();
                    $scope.getUserRobots();

                    /*console.log("WAIT TO SEND...");
                    setTimeout(function() {
                        //var msg = JSON.stringify({mac: "CC:79:CF:AE:07:BC"})
                        var msg = JSON.stringify({"get_map": {"index": 0,"x": 0,"y": 0,"width": 2048,"height": 2048}, mac: "CC:79:CF:AE:07:BC"});
                        $iot.send(msg, "robot/cc79cfae078c/request/get_map/11223344")
                    }, 3000)*/

                    return result.data;
                }).catch(function (err) {
                    return err.data;
                });
              }
            else {
                $ionicLoading.hide();
                $scope.state.error = err;
            }
        });


    };

    if (window.localStorage.getItem('username') && !$scope.state.loged) {
      $scope.state.loged = true;
      $scope.login();
    } else {
        $scope.random = Math.floor(Math.random() * 6) + 1;
    }

    $scope.logout = function () {
        $ionicPopup.show({
            title: 'Logout',
            subTitle: 'Are you sure you would like to Logout?',
            buttons: [
                {
                    text: 'Yes',
                    type: 'button-red',
                    onTap: function(e) {
                        $ionicLoading.show();
                        $authService.clearAll();
                        window.localStorage.clear();
/*                        $scope.random = Math.floor(Math.random() * 6) + 1;
                        $scope.state = {
                            userName: "vasilycrespo@gmail.com",
                            password: "123456",
                            error: null,
                            loged: false,
                            robots: [],
                            uuid: "D43433FGHGTRVBT5432O",
                            product: {},
                            screen: "login",
                            new: {
                                userName: "",
                                password: "",
                            },
                            recoverEmail: "",
                            productName: null,
                            userproductList: [],
                            remember: true
                        };*/
                        $timeout(function() {
                            $window.location.reload();
                        }, 1000)
                    }

                },
                { text: 'No' }
            ]
        });
    }

    $scope.download = function (url, skin, callback, onError) {
        console.log('HPM URL:  ',url);
        if (url.indexOf('plumeriatests') >= 0) {
            console.log('using the Plumeria S3 hpm');
            url = "https://s3-us-west-2.amazonaws.com/tti.plumeriasolutions.com/plumeriatests.hpm";
            // url = "http://127.0.0.1:7878/plumeriatests.hpm";
            // The following line is used by Chris to do tests locally against an Anvil http server
            //url = "http://dist.dev/plumeriatests.hpm";
        };
        //url = "http://192.168.0.157:8080/rogue900series.hpm";
        var errorCallback, fileCreationCallback, downloadCallback, unZipFile, requestFSCallback, getFileCallback, getDirectoryCallback, startServer;
        var httpd = cordova.plugins.CorHttpd;
        var errorCount = 0;
        httpd.stopServer();
        $scope.state.product = {
            name: '',
            url: url,
            fileName: url.substring(url.lastIndexOf('/')+1),
            nativeURL: '',
            dirUrl: '',
            productUrl: ''
        };
        $scope.state.product.name = $scope.state.product.fileName.replace(/\.[^/.]+$/, '');

        requestFSCallback = function (fs) {
            fs.root.getFile(skin + '.hpm', { create: true, exclusive: false }, getFileCallback, errorCallback);
            fs.root.getDirectory('zip-output-' + skin, {create: true}, getDirectoryCallback, errorCallback);
        };

        getFileCallback = function (fileEntry) {
            $scope.state.product.nativeURL = fileEntry.nativeURL;
            fileCreationCallback(fileEntry, url, true);
        };

        getDirectoryCallback = function(fileEntry) {
            $scope.state.product.dirUrl = fileEntry.toURL();
        };

        errorCallback = function (e) {
            errorCount++;
            if (errorCount === 1 && onError) {
                onError(e)
            }

        };

        fileCreationCallback = function (fileEntry, uri, readBinaryData) {
            var fileTransfer = new FileTransfer();
            fileTransfer.download(uri, fileEntry.toURL(), downloadCallback, errorCallback);
        };

        downloadCallback = function (entry) {
            $scope.state.product.nativeURL = entry.toURL();
            unZipFile();
        };

        unZipFile = function () {
            zip.unzip($scope.state.product.nativeURL, $scope.state.product.dirUrl, function(result) {
            $scope.state.product.productUrl =  $scope.state.product.dirUrl + skin + '/';
            if (typeof callback === 'function') {
                callback($scope.state.product.productUrl);
            }
            });
        };

        window.requestFileSystem(window.PERSISTENT, 20 * 1024 * 1024, requestFSCallback, errorCallback);
    };

    $scope.readFile = function (productName, onSuccess, onError) {
        var getDirectoryCallback = function(fileEntry) {
            var url = fileEntry.toURL() + productName + '/version.json';
            var baseUrl =  fileEntry.toURL() + productName + '/';
            $http.get(url).then(function (r) {
                console.log("LOCAL VERSION DETECTED: " + r.data.version);
                onSuccess(r.data.version, baseUrl)
            }, function (e) {
                onError(e);
            });
        };
        var errorCallback = function (e) {
            onError(e);
        };
        var requestFSCallback = function (fs) {
            fs.root.getDirectory('zip-output-' + productName, {create: false}, getDirectoryCallback, errorCallback);
        };
        window.requestFileSystem(window.PERSISTENT, 20 * 1024 * 1024, requestFSCallback, errorCallback);
    }

    $scope.select = function (robot) {
        /*window.localStorage.setItem('selectedProductUid', robot.id);
        window.localStorage.setItem('selectedProductRobartId', robot.robot_id);
        alert("selected ->" + robot.id)
        return;*/

        var config = robot.config
        if (config && config !== null) {
            var parseConfig = JSON.parse(config);
            parseConfig.forEach(function (conf) {
                window.localStorage.setItem(Object.keys(conf)[0], conf[Object.keys(conf)[0]])
            })
        }
        $ionicLoading.show();
        var useLocalHPM = function (baseUrl) {
            var url = (robot.userStaticUrl !== null) ? robot.userStaticUrl : baseUrl;
            window.localStorage.setItem('userStaticUrl', url);
            window.localStorage.setItem('appStyle', robot.appStyle);
            window.localStorage.setItem('selectedProductUid', robot.id);
            window.localStorage.setItem('selectedProductRobartId', robot.robot_id);
            window.localStorage.setItem('appInformation', JSON.stringify(robot.product));
            window.localStorage.setItem('restartingApp', "true");
            window.localStorage.setItem('debug', robot.debug);
            $timeout(function() { $window.location.reload(true); }, 1500);
        };
        var downloadNewHPM = function () {
            var downloadError = function(error) {
                $ionicLoading.hide();
                $ionicPopup.alert({title: 'Network error',template: 'A network error was detected please try again.'});
            }
            $scope.download(robot.product.hpm, robot.product.skin, function (response) {
                window.localStorage.setItem('userStaticUrl', response);
                window.localStorage.setItem('appStyle', robot.appStyle);
                window.localStorage.setItem('selectedProductUid', robot.id);
                window.localStorage.setItem('selectedProductRobartId', robot.robot_id);
                window.localStorage.setItem('appInformation', JSON.stringify(robot.product));
                window.localStorage.setItem('restartingApp', "true");
                window.localStorage.setItem('debug', robot.debug);
                $timeout(function() { $window.location.reload(true); }, 1500);
                $scope.$apply();
            }, downloadError);
        };
        var showPopup = function (baseUrl) {
            $ionicLoading.hide();
            /*
            $ionicPopup.show({
                    title: 'New version available!',
                    template: '<p style="margin-top: 20px; color: #333;">A new version of this product is available,</p><p style="color: #333;">do you want to download it?</p>',
                    buttons: [
                        {
                            text: 'Omit',
                            onTap: function(e) {
                                $ionicLoading.show();
                                useLocalHPM(baseUrl);
                            }
                        },
                        {
                            text: '<b>Download</b>',
                            type: 'button-positive',
                            onTap: function(e) {
                                $ionicLoading.show();
                                downloadNewHPM();
                            }
                        }
                    ]
            })
            */
            $ionicLoading.show();
            downloadNewHPM();
        };

        var getLastVersionFromServer = function () {
            $authService.getApiGatewayClient({username: $scope.state.userName, password: $scope.state.password}, function(err, client){
                if (!err){
                    client.Get('/foundry/devices/by-type', {type_id: "62a0df70-3a34-11e7-8b9e-bf1700f5a25c"}).then(function (result) {
                        var remoteVersion = null;
                        result.data.forEach(function(r) {
                            if (robot.product.typeId === r["deviceId"] ) {
                                remoteVersion =  r["a.version"]
                            }
                        })
                        if (remoteVersion) {
                            console.log("SERVER AVAILABLE VERSION CAPTURED -> " + remoteVersion);
                            var fnSuccess = function (v, baseUrl) {
                                if (remoteVersion.toString() !== v.toString()) {
                                    console.log("NEW VERSION ON SERVER DETECTED");
                                    showPopup(baseUrl);
                                } else {
                                    console.log("SAME VERSION DETECTED");
                                    useLocalHPM(baseUrl);
                                }
                            };

                            var fnError = function (e) {
                                console.log("CANNOT READ LOCAL FILE");
                                downloadNewHPM()
                            };

                            $scope.readFile(robot.appStyle, fnSuccess, fnError)
                        } else {
                            console.log("CAN NOT CAPTURE VERSION FROM SERVER");
                            downloadNewHPM();
                        }
                    })
                }
            });
        };

        getLastVersionFromServer();


/*        if (robot.userStaticUrl !== null) {
            useLocalHPM();
        } else {
            downloadNewHPM();
        }*/
    }

    $scope.confirmName = function (robot, name) {
        var userProducUid = new Date().getTime();
        userProducUid =  new UUID(1).toString();

        if ($scope.robotNamePopup) {
            $scope.robotNamePopup.close();
        }

        var list = [];
        if ($scope.state.userproductList && $scope.state.userproductList !== null && $scope.state.userproductList.length > 0) {
            list = $scope.state.userproductList;
        }
        $ionicLoading.show();

        var credentials = {
            username: $scope.state.userName,
            password: $scope.state.password
        }
        console.log('Credentials:  ',credentials);


        var post = function () {
            var add_product = {
                "deviceId": userProducUid,
                "accountId": window.localStorage.getItem('userId'),
                "typeId": 'fb648690-3eed-11e7-9b5d-5763b2661e96',
                "a.product": robot.typeId
            }
            window.localStorage.setItem('add_product', JSON.stringify(add_product));
            startDownload(function(error) {
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: 'Network error',
                    template: 'A network error was detected please try again.'
                });
            });
        };

        var startDownload = function (onError) {
            $scope.download(robot.hpm, robot.skin, function (response) {
                list.push({id: userProducUid, "name": "", product: robot, userStaticUrl: response, 'appStyle': robot.skin, 'config': null});
                window.localStorage.setItem("userproductList", JSON.stringify(list));
                $scope.state.userproductList = list;
                $ionicLoading.hide();
                setTimeout(function() {
                    var userProduct = list[list.length - 1];
                    $scope.select(userProduct);
                }, 200);
                $scope.$apply();
            }, onError);
        };

        post();
    };

    $scope.cancel = function () {
        $scope.robotNamePopup.close();
    }

    $scope.addRogue = function () {
        console.log('running addRogue');
//      For Rogue 900 Series
/*        var robot = {
        hpm: 'https://tti-firmwares-dev.s3-us-west-2.amazonaws.com/rogue900series-1510331919205.hpm',
        image: 'https://tti-firmwares-dev.s3-us-west-2.amazonaws.com/robot-side-icn-1507769619193.png',
        name: 'Rogue 900 Series',
        skin: 'rogue900series',
        typeId: '582ff050-aee5-11e7-86e9-493603f04d75',
        version: '25'
        }*/

//      For Rogue 900 Prerelease
/*        var robot = {
        hpm: 'https://s3-us-west-2.amazonaws.com/tti.plumeriasolutions.com/rogue9xxprerelease.hpm',
        image: 'https://tti-firmwares-dev.s3-us-west-2.amazonaws.com/hoover-1504884767710.png',
        name: 'Rogue 9xx - Prerelease',
        skin: 'rogue9xxprerelease',
        typeId: '28b77680-94ab-11e7-8f56-e50745e69935',
        version: '1'
        }
*/
//      For Rogue 950CP - Consumer Panel
/*        var robot = {
        hpm: 'https://tti-firmwares-dev.s3-us-west-2.amazonaws.com/rogue950cp-1506500620913.hpm',
        image: 'https://tti-firmwares-dev.s3-us-west-2.amazonaws.com/robot-side-icn-1506498972433.png',
        name: 'Rogue 950CP',
        skin: 'rogue950cp',
        typeId: '15912d70-9e8e-11e7-b7e5-6d2d201cef20',
        version: '22'
        }*/
//      For Rogue 950
/*
        var robot = {
        hpm: 'https://s3-us-west-2.amazonaws.com/tti.plumeriasolutions.com/rogue950.hpm',
        image: 'https://tti-firmwares-dev.s3-us-west-2.amazonaws.com/robot-side icon-1505974661417.png',
        name: 'Rogue 950',
        skin: 'rogue950',
        typeId: '8c9bc550-8bc0-11e7-9810-b36c8453e759',
        version: '1'
        }
*/

        //Dinamic get of last Foundry HPM for rogue900series

        //rogue900series
        var robot = $scope.state.robots.filter(function(r) { return r.skin === "rogue900series"})

        if (robot.length === 0) {
            // Default rogue900series
            var robot = {
                hpm: 'https://tti-firmwares-dev.s3-us-west-2.amazonaws.com/rogue900series-1510331919205.hpm',
                image: 'https://tti-firmwares-dev.s3-us-west-2.amazonaws.com/robot-side-icn-1507769619193.png',
                name: 'Rogue 900 Series',
                skin: 'rogue900series',
                typeId: '582ff050-aee5-11e7-86e9-493603f04d75',
                version: '25'
            }
        } else {
            robot = robot[0]
        }

        $scope.state.selectedProduct = robot;
        $scope.state.productName = robot.name;
        $scope.confirmName(robot, robot.name);

        };

    $scope.pickProduct = function (robot) {
        // The Following lines are used to fake out the "Add Robot" so that users are prompted with a list.  Also change the function call to function() and change the onClick to pickProduct();
        /*
        var robot = {
        hpm: 'https://tti-firmwares-dev.s3-us-west-2.amazonaws.com/rogue950-1503904414504.hpm',
        image: 'https://tti-firmwares-dev.s3-us-west-2.amazonaws.com/rogue950-1503904465013.png',
        name: 'Rogue 950',
        skin: 'rogue950',
        typeId: '8c9bc550-8bc0-11e7-9810-b36c8453e759',
        version: '1'
        };
        */

        $scope.robotPopup.close();

        $scope.state.selectedProduct = robot;
        $scope.state.productName = robot.name;
        $scope.confirmName($scope.state.selectedProduct, $scope.state.productName);

        /*var template = '<div class="item item-input-inset">\
                            <label class="item-input-wrapper">\
                              <input type="text" ng-model="state.productName" placeholder="Give a product name">\
                            </label>\
                        </div>\
                        <button ng-click="confirmName(state.selectedProduct, state.productName)" class="btn-red">Add</button>\
                        <button class="white-text" ng-click="cancel()">Cancel</button>';
        $scope.robotNamePopup = $ionicPopup.show({
            template: template,
            title: 'Add a name to your ' + robot.name,
            scope: $scope
        });*/
    };

    $scope.showRobotList = function () {
        $scope.state.productName = "";
/*                <div ng-repeat="robot in state.userproductList track by $index" class="robot-item" ng-click="select(robot)">
          <div class="rImg" style="background-image: url('{{robot.product.image}}')"></div>
          <div class="rTitle">{{robot.name}}</div>
          <div class="rSub">{{robot.product.name}}</div>
          <div class="robot-item-btn">Pick</div>
        </div>*/


        //var template = '<div class="robot-item robot-item-popup" style="background-image: '../img/rogue.jpg'/<div>';

        var template = '<div ng-repeat="robot in state.robots" class="robot-item robot-item-popup" ng-click="pickProduct(robot)">\
                            <div class="rImg" style="background-image: url(\'{{robot.image}}\')"></div>\
                            <div class="rTitle">{{robot.name}}</div>\
                            <div class="robot-item-btn">Select</div>\
                        </div>';

        $scope.robotPopup = $ionicPopup.show({
            template: template,
            title: 'Select a product',
            scope: $scope,
            buttons: [{ text: 'Cancel' }]
        });
    };

    $scope.getTitle = function () {
        var title = "";
/*        switch($scope.state.screen) {
            case "register":
                title = "REGISTER";
                break;
            case "forgot":
                title = "Password Recover";
                break;
            case "login":
                title = "LOGIN";
                break;
        }*/
        if ($scope.state.loged) title = "HOME";
        return title;
    };

    $scope.remove = function (device, robotI) {
        var removeI = null;
        $scope.state.userproductList.forEach(function(e, i) {
            if (device.id === e.id) {
                removeI = i;
            }
        })
        if (removeI !== null) {
            $scope.state.userproductList[removeI].removing = true;
        } else {
            return;
        }
        var rm = function () {
            $timeout(function() {
                $authService.getApiGatewayClient({username: $scope.state.userName, password: $scope.state.password}, function(err, client){
                    if (!err){
                        client.Delete('/foundry/device/' + device.id, {},  {action: 'delete'}).then(function (result) {}).catch(function (err) {});
                    }
                });
            }, 0);
        };
        $timeout(function() {
            var copyList = angular.copy($scope.state.userproductList).splice(removeI, 1);
            window.localStorage.setItem("userproductList", JSON.stringify(copyList));
            rm();
        }, 1000);
    };

    $scope.reenableClick = function () {
        $timeout(function () {
            $scope.state.disableClick = false;
        }, 500)
    };

    $scope.onForgot = function () {
        if ($scope.state.userName) {
            $scope.state.recoverEmail = angular.copy($scope.state.userName);
        }
        $scope.state.screen = 'forgot';
    };

    $scope.openLogin = function () {
        $scope.state.userName = "";
        $scope.state.password = "";
        $scope.state.screen = 'login';
    };

    $scope.switchNewPasswordType = function () {
        console.log("RNJSC", "Here")
        if ($scope.state.newPasswordType === "password") {
            $scope.state.newPasswordType = "text";
        } else {
            $scope.state.newPasswordType = "password";
        };
    }

    $scope.ifEnter = function (event) {
        if (event.keyCode === 13) {
            $scope.login();
            document.activeElement.blur();
        }
    };

    $scope.clearProductCache = function () {
        var uid = window.localStorage.getItem("selectedProductUid");
        if (uid && uid !== null && (typeof uid !== "undefined") && uid.length > 5) {
            console.log( "CLEARING PRODUCT CACHE...");
            window.localStorage.removeItem("appInformation");
            window.localStorage.removeItem("appStyle");
            window.localStorage.removeItem("selectedProductUid");
            window.localStorage.removeItem("userStaticUrl");
            window.localStorage.removeItem("switcRobot");
            window.localStorage.removeItem("currentConfig");
            window.localStorage.removeItem('selectedProductRobartId');
            window.localStorage.removeItem(uid + "-ROBART_VACUUMS");
            window.localStorage.removeItem(uid + "-apiAddress");
            window.localStorage.removeItem(uid + "-historyList");
            window.localStorage.removeItem(uid + "-language");
            window.localStorage.removeItem(uid + "-robart.SSID");
            window.localStorage.removeItem(uid + "-robart.robot_list");
            window.localStorage.removeItem(uid + "-robart.uiDList");
            window.localStorage.removeItem(uid + "-robotName");
            window.localStorage.removeItem(uid + "-name_set_config");
            window.localStorage.removeItem(uid + "-robart_plugin_body");
            window.localStorage.removeItem(uid + "-robot_config");
            window.localStorage.removeItem(uid + "-robot_config_id");
            window.localStorage.removeItem(uid + "-wifiCredentials");
        }
    };

    $scope.hidenOn = false;

    $scope.onHold = function (e) {
        e.preventDefault();
        e.stopPropagation();
        $scope.HDmenuTO = $timeout(function () {
            $scope.hidenOn = true;
            $scope.hiddenValues = {};
            $ionicPopup.show({
                title: 'Delete',
                subTitle: 'Please input debug password.',
                template: '<p><input class="hidden-input" type="password" placeholder="Password" ng-model="hiddenValues.pin"/></p>',
                scope: $scope,
                buttons: [
                    { text: 'Cancel', onTap: function(e) { $scope.hidenOn = false; }},
                    {
                        text: 'Continue',
                        type: 'button-positive',
                        onTap: function(e) {
                            $scope.hidenOn = false;
                            if ($scope.hiddenValues.pin === "tti") {
                                $scope.showRobotList();
                            };
                        }
                    }
                ]
            });
        }, 8000);
    };

    $scope.onRelease = function (e) {
        e.preventDefault();
        e.stopPropagation();
        $timeout.cancel($scope.HDmenuTO);

        if (!$scope.hidenOn) {
            $scope.addRogue($scope.robot)
        }

    };

}]);
app.directive('secretmenu', function ($timeout) {
  return {
    restrict: 'A',
    template: '{{message}}',
    link: function(scope, element, attrs, ctrl) {
      var timeout = null
      scope.message = ""
      element.bind('mousedown', function (e) {
        timeout = $timeout(function(){
          $scope.showRobotList();
          console.log('long press')
        }, 5000)
      })
      element.bind('mouseup', function (e) {
        timeout = null
      })
    }

  }
});

app.directive('watchSwipe', function ($timeout) {
  return {
    link: function(scope, element, attrs, ctrl) {
        var targetNode = angular.element(element).children()[1];
        var config = {attributes: true};
        var callback = function(mutationsList) {
            for(var mutation of mutationsList) {
                if (mutation.type === 'attributes' && mutation.attributeName === "style") {
                    var el = angular.element(mutation.target);
                    var option = angular.element(el.parent().children()[0]).children().children();
                    if (el && !!el.css("transform")) {
                        var x = Math.abs(parseInt(el.css("transform").split("translate3d(")[1].split("px,")[0]))
                        option.css('width', x + 'px');
                    } else {
                        option.css('width', '0px');
                    }
                }
            }
        };
        var observer = new MutationObserver(callback);
        observer.observe(targetNode, config);
    }
  }
});
