// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'

var app = angular.module('starter', ['ionic', '$authService', '$iot'])

app.run(function ($ionicPlatform) {
    $ionicPlatform.ready(function () {

        if (typeof PushNotification === "undefined") {
            var push = {on: function (event, cb) {
                    if (event === "registration") cb({registrationId: 123456})
                }}
        } else {
            var push = PushNotification.init({ ios: { alert: "true", badge: "true", sound: "true" } });
        }

        push.on('registration', function (data) {
            if (data.registrationId) {
                window.localStorage.setItem('token', data.registrationId)
            }
        });

        push.on('notification', function (data) {
            alert('Notification Received' + JSON.stringify(data));
        });

        push.on('error', function (e) {
            console.log('Notification Error', e);
        });

        if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            cordova.plugins.Keyboard.disableScroll(true);
        }

        if (window.StatusBar) {
            StatusBar.overlaysWebView(true);
            StatusBar.style(1);
        }
    });
});
