var API_Gateway_For_Device = "https://2mk786bvj2.execute-api.us-east-1.amazonaws.com/v2stage";
var COGNITO_AUTH_PROVIDER_NAME = 'login.tti.stage';
var COGNITO_IDENTITY_POOL_ID = 'us-east-1:f67b4493-2802-4f47-91e1-dcebc748e6e9';
var uid, key;

//TODO porque está hardcodeado?

var user = {
    "Username": "cvoisey",
    "Password": "242062aacee32a1af4be2aca99a5a17f" //CryptoJS.MD5(password).toString();
};
function login(username, password, cbLogin) {

    if (!uid) {
        uid = uuid.v1();
    }

    var timestamp = new Date().toISOString();
    var signature = CryptoJS.HmacSHA256(timestamp, computeDecryptionKey(username, password));
    var hexSign = signature.toString(CryptoJS.enc.Hex);

    var loginURL = API_Gateway_For_Device + '/foundry/login?uid='+ uid + '&username=' + encodeURIComponent(username) + '&timestamp='+ timestamp +'&signature=' + hexSign;

    $.ajax(loginURL)
        .always(function(data, status){// your code here
            if (status == "error") return cbLogin("error");
            var key1 = computeDecryptionKey(username, password).substring(0,32);
            var json = decrypt(data, key1);
            key = json.key;

            getToken(uid, username, null, function(err,data){
                cbLogin(err);
            });
        });

}

function computeDecryptionKey(username, password) {

    var l = document.createElement("a");
    l.href = API_Gateway_For_Device;
    var host = l.hostname;
    var salt = username+COGNITO_AUTH_PROVIDER_NAME+host;
    var hashedSalt = CryptoJS.HmacSHA256(salt, password);
    return hashedSalt.toString(CryptoJS.enc.Hex);

}


function byteArrayToWordArray(ba) {
    var wa = [],
        i;
    for (i = 0; i < ba.length; i++) {
        wa[(i / 4) | 0] |= ba[i] << (24 - 8 * i);
    }

    return CryptoJS.lib.WordArray.create(wa, ba.length);
}

function decrypt(data,key){

    if(typeof data == 'string') {

        var byteCharacters = window.atob(data);
        var iv = new Array(16);
        var crypttext = new Array(byteCharacters.length - 16);

        for (var i = 0; i < byteCharacters.length; i++) {
            if (i < 16)
                iv[i] = byteCharacters.charCodeAt(i);
            else
                crypttext[i - 16] = byteCharacters.charCodeAt(i);
        }

        var cipherParams = CryptoJS.lib.CipherParams.create({
            ciphertext: byteArrayToWordArray(crypttext)
        });
        var plaintextArray = CryptoJS.AES.decrypt(
            cipherParams,
            CryptoJS.enc.Hex.parse(key),
            {iv: byteArrayToWordArray(iv), mode: CryptoJS.mode.CBC, keySize: 128}
        );
        //console.log(JSON.parse(CryptoJS.enc.Latin1.stringify(plaintextArray)))
        return JSON.parse(CryptoJS.enc.Latin1.stringify(plaintextArray));

    } else {
        return data;
    }

}

function getToken(uid, username, identityId, cbGetToken) {

    var logins = {};
    logins[COGNITO_AUTH_PROVIDER_NAME] = username;

    var timestamp = new Date().toISOString();
    var stringToSign = timestamp;
    var providerParams = '';
    var loginCount = 1;

    for (var provider in logins){
        if (logins.hasOwnProperty(provider)) {
            stringToSign += provider + logins[provider];
            providerParams += '&provider'+loginCount+'='+provider+'&token'+loginCount+'='+encodeURIComponent(logins[provider]);
            loginCount++;
        }
    }

    if (identityId) {
        stringToSign += identityId;
        providerParams += '&identityId='+encodeURIComponent(identityId);
    }

    var signature = CryptoJS.HmacSHA256(stringToSign, key);
    var hexSign = signature.toString(CryptoJS.enc.Hex);

    var getTokenURL = API_Gateway_For_Device + '/foundry/token?uid='+ uid + '&timestamp='+ timestamp + providerParams + '&signature=' + hexSign;

    $.ajax(getTokenURL)
        .always(function(data, status){// your code here
            if (status == "error") return cbGetToken("error");
            var json = decrypt(data, key);


            getAWSCredentials(json.identityId,json.token, function(err){
                cbGetToken(err);
            })
        });

}


function getAWSCredentials(identity_id, token, cbGetAWSCredentials) {
    AWS.config.region = COGNITO_IDENTITY_POOL_ID.split(':')[0];
    AWS.config.credentials = new AWS.CognitoIdentityCredentials({
        IdentityPoolId: COGNITO_IDENTITY_POOL_ID,
        IdentityId: identity_id,
        Logins: {
            'cognito-identity.amazonaws.com': token
        }
    });

    AWS.config.credentials.get(function (err) {

        if (err) {
            return cbGetAWSCredentials(err);
        }

        return cbGetAWSCredentials(null);

    });

}

function checkAWSCredentials(cbCheckAWSCredentials) {


    var currentTime = moment().valueOf();
    var expireTime = 0;
    if (AWS.config.credentials !== null) {
        expireTime = moment(AWS.config.credentials.expireTime).valueOf();
    }

    if ((AWS.config.credentials === null || AWS.config.credentials.expired || currentTime >= expireTime)) {

        if (uid && key) {

            getToken(uid, user.Username, null, function(err){
                cbCheckAWSCredentials(err);
            });

        } else {

            login(user.Username, user.Password, function(err,data){
                cbCheckAWSCredentials(err);
            })

        }

    } else {
        cbCheckAWSCredentials(null);
    }
}

function getApiGatewayClient(cbGetApiClient){

    checkAWSCredentials(function(err){
        if (err) {
            key = null;
            return cbGetApiClient(err);
        }

        var config = {
            accessKey: AWS.config.credentials.accessKeyId,
            secretKey: AWS.config.credentials.secretAccessKey,
            sessionToken: AWS.config.credentials.sessionToken,
            invokeUrl: API_Gateway_For_Device,
            region: COGNITO_IDENTITY_POOL_ID.split(':')[0]
        };

        var apiClient = apigClientFactory.newClient(config);
        return cbGetApiClient(null,apiClient);
    })

}